#extension GL_EXT_gpu_shader4 : enable

uniform sampler2D textureImage;
uniform int type;
uniform float width;
uniform int quality;
uniform int rayNum;
uniform float offset;
uniform float crit;
uniform float enhance;
uniform float fade;

void main (void)
{
    gl_FragColor = vec4(0, 0, 0 ,0);

    float angleOffset = offset * 3.14159 / 180;
    vec2 st = gl_TexCoord[0].st;

    if (type == 0){
	for (int ray = 0; ray < rayNum; ray++){
	    float angle = angleOffset + ray * 3.14159 / rayNum;
	    vec2 dir = vec2(cos(angle), sin(angle));
	    for (int i = 0; i < quality*2+1; i++){
		float dx = float(i-quality) / quality * width;
		vec4 texColor = texture2D(textureImage, st + dx * dir);
		float factor = pow(fade, abs(float(i-quality)));

		if (texColor[3] > 1){
		    texColor[0] *= texColor[3];
		    texColor[1] *= texColor[3];
		    texColor[2] *= texColor[3];
		    texColor[3] = 1;
		}

		if (i == quality){
		    if (ray == 0)
			gl_FragColor += texColor;
		}
		else{
		    float str = length(vec3(texColor));
		    str *= texColor[3];
		    if (str - crit > 0)
			gl_FragColor += texColor / (quality*2+1) * (str-crit) * enhance * factor;
		}

	    }
	}
    }

    if (type == 1){
	for (int j = 0; j < quality*2+1; j++){
	    float dy = float(j-quality) / quality * width;
	    float factory = pow(fade, abs(float(j-quality)));
	    for (int i = 0; i < quality*2+1; i++){
		float dx = float(i-quality) / quality * width;
		vec4 texColor = texture2D(textureImage, st + vec2(dx, dy));
		float factorx = pow(fade, abs(float(i-quality)));
		
		if (texColor[3] > 1){
		    texColor[0] *= texColor[3];
		    texColor[1] *= texColor[3];
		    texColor[2] *= texColor[3];
		    texColor[3] = 1;
		}
		
		if (i == quality && j == quality)
		    gl_FragColor += texColor;
		else{
		    float str = length(vec3(texColor));
		    str *= texColor[3];
		    if (str - crit > 0)
			gl_FragColor += texColor / (quality*2+1) * (str-crit) * enhance * factorx * factory;
		}
	    }
	}
    }

    if (gl_FragColor[3] > 1){
	gl_FragColor[3] = 1;
    }
    
    return;



}
